<?php
/**
 * The notification Post Type
 */

if ( !defined( 'ABSPATH' ) )
	die( '-1' );

if ( ! class_exists( 'Studiare_Notification' ) ) {

	class Studiare_Notification {

		public static $instance;

		// Setup a single instance using the singleton pattern
		public static function init() {

			if ( is_null( self::$instance ) ) {
				self::$instance = new Studiare_Notification();
			}
			return self::$instance;

		}

		function __construct() {

			add_action( 'init', array($this, 'register_post_type' ), 5 );
			add_action( 'cmb2_admin_init', array($this,'register_meta_boxes' ));

			if( is_admin() ) {

				add_filter( 'manage_edit-teacher_columns' , array( $this,'add_sc_notification_columns' ) );
				

			}
		}

		function register_post_type() {

 			//$options = get_option( 'studiare-core-options' );
			//$options = codebean_option( 'sc_notification-slug' );
			$options = "";
			if(empty($options) || $options=='' || $options==null){
			    $options = 'notifications';
			}

			if ( post_type_exists( 'sc_notification' ) ) {
				return;
			}

			$labels = array(
				'name'                => _x( 'اطلاعیه', 'Post Type General Name', 'studiare-core' ),
				'singular_name'       => _x( 'اطلاعیه', 'Post Type Singular Name', 'studiare-core' ),
				'menu_name'           => __( 'اطلاعیه', 'studiare-core' ),
				'parent_item_colon'   => __( 'اطلاعیه والد:', 'studiare-core' ),
				'all_items'           => __( ' اطلاعیه ها', 'studiare-core' ),
				'view_item'           => __( 'مشاهده', 'studiare-core' ),
				'add_new_item'        => __( 'افزودن جدید', 'studiare-core' ),
				'add_new'             => __( 'افزودن جدید', 'studiare-core' ),
				'edit_item'           => __( 'ویرایش اطلاعیه', 'studiare-core' ),
				'update_item'         => __( 'بروزرسانی اطلاعیه', 'studiare-core' ),
				'search_items'        => __( 'جستجوی اطلاعیه', 'studiare-core' ),
				'not_found'           => __( 'یافت نشد', 'studiare-core' ),
				'not_found_in_trash'  => __( 'در سطل زباله یافت نشد', 'studiare-core' ),
			);

			$rewrite = array(
				'slug'                => $options,
				'with_front'          => false,
			);

			$args = array(
				'label'               => __( 'download', 'studiare-core' ),
				'description'         => __( 'Download Post Type', 'studiare-core' ),
				'labels'              => $labels,
				// 'supports'            => array( 'title', 'editor', 'thumbnail', 'excerpt' ),
				'supports'            => array( 'title', 'editor' ),
				'hierarchical'        => false,
				'public'              => true,
				'show_ui'             => true,
				'show_in_menu'        => false,//'woocommerce',
				'show_in_nav_menus'   => false,
				'show_in_admin_bar'   => true,
				'menu_position'       => 20,
				'can_export'          => true,
				'has_archive'         => true,
				'exclude_from_search' => true,
				'publicly_queryable'  => true,
				'query_var'           => true,
				'rewrite'             => $rewrite,
				'menu_icon'           => 'dashicons-bell',
				'capability_type'     => 'post',
			);

			register_post_type( 'sc_notification', $args );

		}

		function register_meta_boxes() {

			$prefix = '_studiare_';

			/* $sc_notification_metaboxes = new_cmb2_box( array(
				'id'           => 'sc_notification_metabox',
				'title'        => esc_html__( 'اطلاعات اطلاعیه', 'studiare' ),
				'object_types' => array( 'sc_notification' ),
				'context'      => 'normal',
				'priority'     => 'high',
				'show_names'   => true,
			) ); */

			

			/* $sc_notification_metaboxes->add_field( array(
				'name' => esc_html__( 'لینک فایل', 'studiare' ),
				'id' => 'file_url',
				'type' => 'file',
			) ); */

			
			
		}

		function add_sc_notification_columns( $cols ) {

			$cols = array(
				'cb'        =>   '<input type="checkbox" />',
				'title'     => __( 'عنوان', 'studiare-core' ),
				'thumbnail' => __( 'Thumbnail', 'studiare-core')
			);

			return $cols;

		}

		

	}

	Studiare_Notification::init();
}
