<?php
// suncode localization file for estudiare plugins
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
function studiare_plugin_load_my_own_textdomain( $mofile, $domain ) {
    if ( 'revslider' === $domain && false !== strpos( $mofile, WP_LANG_DIR . '/plugins/' ) ) {
        $locale = apply_filters( 'plugin_locale', determine_locale(), $domain );
        $mofile = WP_PLUGIN_DIR . '/' . dirname( plugin_basename( __FILE__ ) ) . '/languages/revslider-fa_IR.mo';
    }
    return $mofile;
}
//add_filter( 'load_textdomain_mofile', 'studiare_plugin_load_my_own_textdomain', 10, 2 );

function studiare_revslider_data_get_font_familys( $fonts ) {

	$persian_fonts = [];

	//Web Safe fonts

	// Persian Fonts
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'sc_dana');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'sc_iran');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'sc_anjoman');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'sc_iransans');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'IRANSansX_SunCode');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'IRANSansX_English_Numbers');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'sc_iranyekan');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'sc_iransansdn');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'Pelak');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'Doran');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'Azhdar');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'sc_mahboobeh');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'Shabnam');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'scmahboobeh');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'Shabnam-Bold');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'irsns-light-fa');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'irsns-regular-fa');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'irsns-bold-fa');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'Lalezar-Regular');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'broyabold');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'rezvan');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'khodkar');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'DastNevis');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'BTitrBold');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'BYekan');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'BZar');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'BSinaBold');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'BZiba');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'Javanweb');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'Yekan_Bakh');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'Modam');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'farhang_fa_num');
			$fonts[] = array('type' => 'websafe', 'version' => __('Persian Fonts', 'revslider'), 'label' => 'rokh');

	return wp_parse_args( $fonts, $persian_fonts );
}
add_filter( 'revslider_data_get_font_familys', 'studiare_revslider_data_get_font_familys' );
function studiare_add_rtl_studiare_front() {
	wp_enqueue_style( 'rtl-studiare-front', plugin_dir_url(__FILE__) . 'css/rtl-studiare-front.css' );
}
add_action( 'wp_enqueue_scripts', 'studiare_add_rtl_studiare_front' );

function suncode_admin_notice_warning() {

	if ( is_plugin_active( 'wp-events-manager-woo-payment/wp-events-manager-woo-payment.php' ) ) {
		?>
			<div class="notice notice-warning">
				<p>لطفا افزونه "WP Events Manager - WooCommerce Payment Methods Integration (افزونه اتصال مدیر رویدادها به ووکامرس)" را غیرفعال کنید (سپس پاک کنید) <br/>
از نگارش 12.4 به بالاتر دیگر نیازی به این افزونه نمی باشد.
</p>
			</div>
			
		<?php
	}
	if ( is_plugin_active( 'cmb2/init.php' ) ) {
		?>
			<div class="notice notice-warning">
لطفا افزونه CMB2 را غیرفعال نمایید. از نسخه 12.4 به بالاتر دیگر نیازی به این افزونه نمی باشد.
			</div>
			
		<?php
	}
	
	if ( is_plugin_active( 'breadcrumb-navxt/breadcrumb-navxt.php' ) ) {
		?>
			<div class="notice notice-warning">
لطفا افزونه عنوان ها و مسیرهای سایت  ( Breadcrumb NavXT) را غیرفعال نمایید. از نسخه 12.4 به بالاتر دیگر نیازی به این افزونه نمی باشد.
			</div>
			
		<?php
	}
	if ( is_plugin_active( 'wp-tab-widget/wp-tab-widget.php' ) ) {
		?>
			<div class="notice notice-warning">
لطفا افزونه تب های وردپرس  (  WP Tab Widget) را غیرفعال نمایید. از نسخه 12.4 به بالاتر دیگر نیازی به این افزونه نمی باشد.
			</div>
			
		<?php
	}
		if ( is_plugin_active( 'portfolio-post-type/portfolio-post-type.php' ) ) {
		    ?>
			<div class="notice notice-warning">
				<p>لطفا افزونه پست تایپ نمونه کار (Portfolio Post Type) را غیرفعال سپس حذف نمایید.
از نگارش 12.4 به بالاتر دیگر نیازی به این افزونه نمی باشد.
</p>
			</div>
			
		<?php
	
}

}
add_action( 'admin_notices', 'suncode_admin_notice_warning' );