<?php
# Blog Settings
Redux::setSection( $opt_name, array(
	'title' => esc_html__( 'Blog', 'studiare' ),
	'id' => 'blog',
	'icon' => 'fal fa-newspaper',

) );

Redux::setSection( $opt_name, array(
	'title'            => esc_html__( 'Blog Options', 'studiare' ),
	'id'               => 'blog_settings',
	'subsection'       => true,
	'icon' => 'fal fa-newspaper',
	'fields'           => array(
		array(
			'id'        => 'blog_post_style',
			'type'      => 'button_set',
			'title'     => esc_html__( 'Blog Layout', 'studiare' ),
			'default'   => 'list',
			'options'   => array(
				'list' => esc_html__( 'List View', 'studiare' ),
				'grid' => esc_html__( 'Grid View', 'studiare' ),
			)
		),
		array(
			'id'        => 'place_of_discriptions_of_cats_blog',
			'type'      => 'select',
			'title'     => esc_html__( 'Category Description Position', 'studiare' ),
			'subtitle'  => esc_html__( 'Show Category Description Before or After Category Posts.', 'studiare' ),
			'options'   => array(
				'top' => esc_html__( 'Top', 'studiare' ),
				'bottom' => esc_html__( 'Bottom', 'studiare' ),
			),
			'default'   => 'bottom',
			'select2'   => array('allowClear' => false)
		),
		array( 
			'id' => 'blog_grid_columns',
			'type' => 'select',
			'title' => esc_html__( 'Blog Columns', 'studiare' ),
			'subtitle' => esc_html__( 'Number of Posts in a Row', 'studiare' ),
			'default' => 'three',
			'options' => array(
				'one' => esc_html__( '1-Column', 'studiare' ),
				'two' => esc_html__( '2-Column', 'studiare' ),
				'three' => esc_html__( '3-Column', 'studiare' ),
				'four' => esc_html__( '4-Column', 'studiare' )
			),
			'select2'   => array('allowClear' => false),
			'required'  => array('blog_post_style', '=', 'grid')
		),
		array(
			'id'        => 'sidebar_position',
			'type'      => 'image_select',
			'title'     => esc_html__( 'Sidebar Position', 'studiare' ),
			'default'   => 'right',
			'options'   => array(
				'none'      => array(
					'alt'   => esc_html__( 'No Sidebar', 'studiare' ),
					'img'   => ReduxFramework::$_url.'assets/img/1col.png'
				),
				'left'      => array(
					'alt'   => esc_html__( 'Left Sidebar', 'studiare' ),
					'img'   => ReduxFramework::$_url.'assets/img/2cr.png'
				),
				'right'      => array(
					'alt'   => esc_html__( 'Right Sidebar', 'studiare' ),
					'img'  => ReduxFramework::$_url.'assets/img/2cl.png'
				),
			)
		),
		array(
			'id'        => 'sticky_blog_sidebar',
			'type'      => 'switch',
			'title'     => esc_html__( 'Sticky Sidebar', 'studiare' ),
			'default'   => true,
		),
		array(
			'id'        => 'blog_show_date',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Date', 'studiare' ),
			'default'   => true,
		),
		array(
			'id'        => 'blog_show_author',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Author', 'studiare' ),
			'default'   => true,
		),
		array(
			'id'        => 'blog_show_excerpt',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Excerpt', 'studiare' ),
			'default'   => true,
		),
		array(
			'id'        => 'blog_show_categories',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Categories', 'studiare' ),
			'default'   => true,
		),
	)
) );

$share_story_networks = array(
	'enabled' => array(
		'whatsapp'	=> 'whatsapp',
		'fb'   	 	=> 'Facebook',
		'tw'   	 	=> 'Twitter',
		'email'       => 'email',
		'telegram'       => 'telegram',
	),
);
Redux::setSection( $opt_name, array(
	'title'            => esc_html__( 'Single Post Options', 'studiare' ),
	'id'               => 'sc_single_post_settings',
	'subsection'       => true,
	'icon' => 'fal fa-file-word',
	'fields'           => array(
	    array(
			'id'        => 'article_feautred_image_single_post',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Feautred Image', 'studiare' ),
			'default'   => true,
		),
	    array(
			'id'        => 'article_date_top_single_post',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Date', 'studiare' ),
			'default'   => true,
		),
		array(
			'id'        => 'article_author_top_single_post',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Author', 'studiare' ),
			'default'   => true,
		),
		array(
			'id'        => 'article_cats_top_single_post',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Categories', 'studiare' ),
			'default'   => true,
		),
		array(
			'id'        => 'article_tags_bottom_single_post',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Tags', 'studiare' ),
			'default'   => true,
		),
		array(
			'id'        => 'article_author',
			'type'      => 'switch',
			'title'     => esc_html__( 'Show Author Info', 'studiare' ),
			'subtitle'  => esc_html__( 'Displays author information at the bottom. It will only be displayed if the author description is filled.', 'studiare' ),
			'default'   => true,
		),
		array(
			'id'        => 'blog_navigation',
			'type'      => 'switch',
			'title'     => esc_html__( 'Posts Navigation', 'studiare' ),
			'subtitle'  => esc_html__( 'Show Next and Previos Post Navigation at the Bottom.', 'studiare' ),
			'default'   => true,
		),
	)
) );
Redux::setSection( $opt_name, array(
	'title'            => esc_html__( 'Share Options', 'studiare' ),
	'id'               => 'sharing_settings',
	'subsection'       => true,
	'icon' => 'fal fa-share-alt-square',
	'fields'           => array(
		array(
			'id'       => 'blog_share_story',
			'title'    => esc_html__( 'Share Post', 'studiare' ),
			'type'     => 'switch',
			'default'  => true,
			'on'       => esc_html__( 'Enable', 'studiare' ),
			'off'      => esc_html__( 'Disable', 'studiare' ),
		),
		//array(
		//	'id'       => 'blog_share_story_networks',
		//	'title'    => esc_html__( 'اشتراک گذاری در:', 'studiare' ),
		//	'subtitle' => esc_html__( 'برای فعال کردن یا غیرفعال کردن به داخل باکس مورد نظر بکشید و رها کنید.', 'studiare' ),
		//	'type'     => 'sorter',
		//	'options'  => $share_story_networks,
		//	'required' => array('blog_share_story', '=', '1'),
		//),
	)
) );