<?php

 /**
 * This file will generate studiare panel
 * created date: 18-02-2022 | 1400-11-28
 */

 /**
 * Register Studiare Panel Page.
 */
function studi_add_panel_link() {
    add_menu_page(
        __( 'Studiare Panel', 'studiare' ),
        __( 'Studiare Panel', 'studiare' ),
        'manage_options',
        'studiare_panel',
        'studiare_panel_callback',
        'dashicons-awards',
        3
    );
}
add_action( 'admin_menu', 'studi_add_panel_link' );

function studi_add_panel_link_topbar ($wp_admin_bar) {

    $args = array (
            'id'        => 'studiare-panel',
            'title'     => __( 'Studiare Panel', 'studiare' ),
            'href'      => get_admin_url().'admin.php?page=studiare_panel',
            //'parent'    => 'new-content'
    );

    $wp_admin_bar->add_node( $args );
    
    $args_spanel = array (
            'id'        => 'studiare-theme-settings',
            'title'     => __( 'Theme Settings', 'studiare' ),
            'href'      => get_admin_url().'admin.php?page=theme-options',
            'parent'    => 'studiare-panel'
    );

    $wp_admin_bar->add_node( $args_spanel );
    
    $args_sheader = array (
            'id'        => 'studiare-header',
            'title'     => __( 'Header', 'studiare' ),
            'href'      => get_admin_url().'edit.php?post_type=studi_header',
            'parent'    => 'studiare-panel'
    );

    $wp_admin_bar->add_node( $args_sheader );
    
    $args_sfooter = array (
            'id'        => 'studiare-footer',
            'title'     => __( 'Footer', 'studiare' ),
            'href'      => get_admin_url().'edit.php?post_type=studi_footer',
            'parent'    => 'studiare-panel'
    );

    $wp_admin_bar->add_node( $args_sfooter );
    
    $args_smegamenu = array (
            'id'        => 'studiare-megamenu',
            'title'     => __( 'Megamenu', 'studiare' ),
            'href'      => get_admin_url().'edit.php?post_type=sc_megamenu',
            'parent'    => 'studiare-panel'
    );

    $wp_admin_bar->add_node( $args_smegamenu );
    
    $args_scdownload = array (
            'id'        => 'studiare-download',
            'title'     => __( 'Downloads', 'studiare' ),
            'href'      => get_admin_url().'edit.php?post_type=cdownload',
            'parent'    => 'studiare-panel'
    );

    $wp_admin_bar->add_node( $args_scdownload );
    
    $args_sclessons = array (
            'id'        => 'studiare-lessons',
            'title'     => __( 'Lessons', 'studiare' ),
            'href'      => get_admin_url().'edit.php?post_type=studi_lesson',
            'parent'    => 'studiare-panel'
    );

    $wp_admin_bar->add_node( $args_sclessons );
    
    $args_sc_notification = array (
            'id'        => 'studiare-notifications',
            'title'     => __( 'Notifications', 'studiare' ),
            'href'      => get_admin_url().'edit.php?post_type=sc_notification',
            'parent'    => 'studiare-panel'
    );

    $wp_admin_bar->add_node( $args_sc_notification );
    
    $args_sc_teacher = array (
            'id'        => 'studiare-teacher',
            'title'     => __( 'Teachers', 'studiare' ),
            'href'      => get_admin_url().'edit.php?post_type=teacher',
            'parent'    => 'studiare-panel'
    );

    $wp_admin_bar->add_node( $args_sc_teacher );
    
    $args_sc_iplugins = array (
            'id'        => 'studiare-iplugins',
            'title'     => __( 'Install Plugins', 'studiare' ),
            'href'      => get_admin_url().'themes.php?page=tgmpa-install-plugins',
            'parent'    => 'studiare-panel'
    );

    $wp_admin_bar->add_node( $args_sc_iplugins );
}

add_action('admin_bar_menu', 'studi_add_panel_link_topbar',62);


function studi_add_panel_selector_to_admin(){
    $sc_disable_admin_menu_button = codebean_option('sc_disable_admin_menu_button');
    if ($sc_disable_admin_menu_button) :
    ?>
    <style>
       .studi_panel_btn_link a { position: fixed; left: 40px; bottom: 50px; text-decoration: none; background: #03a9f4; padding: 5px; border-radius: 5px; color: #fafafa; box-shadow: 0 0 10px #64b2d5;font-size: 0; transition: .8s ;}
       .studi_panel_btn_link a:hover { font-size: 12px; }
    </style>
    <div class="studi_panel_btn_link">
        <a href="admin.php?page=studiare_panel"><span class="dashicons dashicons-dashboard"></span><?php echo __( 'Studiare Panel', 'studiare' ); ?></a>
    </div>
    <?php
    endif;
}

add_action( 'admin_footer', 'studi_add_panel_selector_to_admin' );
function studiare_panel_callback(){
    
    ?>
    <style>
        .studiare_panel_holder { margin: 20px auto; max-width: 1024px; }
        .studipnl_header,.studipnl_footer { background: #fff; padding: 20px; border-radius: 7px; box-shadow: 0 0 20px #eceff1; color: #90a4ae;display: flex; justify-content: space-between; }
        .studipnl_header h2 { color: #90a4ae; font-size: 14px; margin: 0; font-weight: 100; }
        .studipnl_content { background: #fff; padding: 20px; border-radius: 7px; box-shadow: 0 0 20px #eceff1; margin: 20px 0;display: flow-root; position: relative;background: repeating-linear-gradient(45deg, white, #fcfdfe 40px); }
        
        
        .studipnl_icon { font-size: 47px; margin-bottom: 15px; color: #eeeeee; position: absolute; transform: rotate(-25deg); bottom: -20px; right: -20px; }
        .studipnl_box a { color: gray; text-decoration: none; font-size: 14px; padding: 0; display: flex; min-height: 100px; align-items: center; justify-content: center; width: 100%;font-variation-settings: "wght" 650; }
        .studipnl_box:hover a, .studipnl_box:hover .studipnl_icon { color: #fff; }
        .studipnl_box:hover { background: #03a9f4;border-radius:10px; }
        .studipnl_box:before { content: ""; width: 50px; height: 50px; background: #03a9f4; position: absolute; left: -25px; top: -25px; border-radius: 0 0 100px;transition: .4s; }
        .studipnl_box:hover:before { transform: scale(2) translate(21px, -6px); z-index: 2; background: #03a9f4; }
        
        .studipnl_boxes { display: block; width: 50%; float: right;}
        .studipnl_box { background:#fff;box-shadow: 0 0 10px #ede7f6; border-radius: 4px; text-align: center; width: calc(33.33% - 30px); margin: 10px; transition: .3s; overflow: hidden; position: relative; min-height: 100px; align-items: center; justify-content: center; display: inline-block; }
        .studipnl_header h2 small { background: gold; border-radius: 3px; position: relative; top: -2px; right: revert; padding: 0 5px; color: yellow; margin: 0 5px; }
        .spicons_description { min-height: 50px; }
        a.sun_rtl_link {color:#80808b; text-decoration: none;  }
        .spicons_cone{width:70%;}
        .spicons_ctwo{width:30%;}
    </style>
    <div class="studiare_panel_holder">
        
        <div class="studipnl_header">
            <h2><?php echo __('Studiare Panel','studiare'); ?><small><?php echo wp_get_theme()->version; ?></small></h2>
        </div>
        
        <div class="studipnl_content">
            
            <div class="studipnl_boxes spicons_cone">
                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('You can change theme options from this page','studiare'); ?>" >
                    <a href="<?php echo get_admin_url().'admin.php?page=theme-options'; ?>">
                        <div class="studipnl_icon"><i class="fal fa-tachometer-alt"></i></div>
                        <?php echo __('Theme Settings','studiare'); ?>
                    </a>
                </div>
                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('Build stunning headers just by few clicks','studiare'); ?>" >
                    <a href="<?php echo get_admin_url().'edit.php?post_type=studi_header'; ?>">
                        <div class="studipnl_icon"><i class="fal fa-desktop"></i></div>
                        <?php echo __('Header','studiare'); ?>
                    </a>
                </div>
                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('Build stunning footers just by few clicks','studiare'); ?>" >
                    <a href="<?php echo get_admin_url().'edit.php?post_type=studi_footer'; ?>">
                        <div class="studipnl_icon"><i class="fal fa-desktop-alt"></i></div>
                        <?php echo __('Footer','studiare'); ?>
                    </a>
                </div>
                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('You can create megamenu as menu item','studiare'); ?>" >
                    <a href="<?php echo get_admin_url().'edit.php?post_type=sc_megamenu'; ?>">
                        <div class="studipnl_icon"><i class="fal fa-memory"></i></div>
                        <?php echo __('Megamenu','studiare'); ?>
                    </a>
                </div>
                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('Create download link for your courses','studiare'); ?>" >
                    <a href="<?php echo get_admin_url().'edit.php?post_type=cdownload'; ?>">
                        <div class="studipnl_icon"><i class="fal fa-cloud-download"></i></div>
                        <?php echo __('Downloads','studiare'); ?>
                    </a>
                </div>
                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('Create lessons for your courses','studiare'); ?>" >
                    <a href="<?php echo get_admin_url().'edit.php?post_type=studi_lesson'; ?>">
                        <div class="studipnl_icon"><i class="fal fa-folder-open"></i></div>
                        <?php echo __('Lessons','studiare'); ?>
                    </a>
                </div>
                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('show notifications in user panel','studiare'); ?>" >
                    <a href="<?php echo get_admin_url().'edit.php?post_type=sc_notification'; ?>">
                        <div class="studipnl_icon"><i class="fal fa-bell-on"></i></div>
                        <?php echo __('Notifications','studiare'); ?>
                    </a>
                </div>
                
           
                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('Manage Teachers','studiare'); ?>" >
                    <a href="<?php echo get_admin_url().'edit.php?post_type=teacher'; ?>">
                        <div class="studipnl_icon"><i class="fal fa-user-graduate"></i></div>
                        <?php echo __('Teachers','studiare'); ?>
                    </a>
                </div>
                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('Install required plugins for theme','studiare'); ?>" >
                    <a href="<?php echo get_admin_url().'themes.php?page=tgmpa-install-plugins'; ?>">
                        <div class="studipnl_icon"><i class="fal fa-desktop"></i></div>
                        <?php echo __('Install Plugins','studiare'); ?>
                    </a>
                </div>

                
                <div class="studipnl_box" data-spicon_desc="<?php echo __('Help Center','studiare'); ?>" >
                    <a target="_blank" href="https://www.rtl-theme.com/dashboard/#/ticket-send">
                        <div class="studipnl_icon"><i class="fal fa-ambulance"></i></div>
                        <?php echo __('Help Center','studiare'); ?>
                    </a>
                </div>
                
            </div>
            <div class="studipnl_boxes spicons_ctwo">
                <?php 
                
                echo __("Studiare Panel Items","studiare"); ?>
                <div class="spicons_description"></div>
                
                
            </div>
            
            
            
        </div>
        <div class="studipnl_footer">
            <a class="sun_rtl_link" target="_blank" href="https://www.rtl-theme.com/author/bagherpebs/products/"><?php echo __('View Suncode Products','studiare'); ?></a>
            <small><?php echo __('All Rights Reserved By Suncode','studiare'); ?> <i class="fal fa-sun"></i></small>
            
        </div>
    </div>
    <script>
        jQuery(document).ready(function(){
            jQuery(".studipnl_box").hover(function(){
                var des = jQuery(this).attr("data-spicon_desc");
                jQuery(".spicons_description").html(des);
            },function(){
                jQuery(".spicons_description").html("");
            });
        });
    </script>
    <?php
    
}
 