<?php
/**
 * Single Product Image
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/product-image.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @author  WooThemes
 * @package WooCommerce/Templates
 * @version 7.8.0
 */

defined( 'ABSPATH' ) || exit;

// Note: `wc_get_gallery_image_html` was added in WC 3.3.2 and did not exist prior. This check protects against theme overrides being used on older versions of WC.
if ( ! function_exists( 'wc_get_gallery_image_html' ) ) {
	return;
}

global $post, $product;

$prefix = '_studiare_';

$course_video = get_post_meta(get_the_ID(), $prefix . 'course_video', true);

// begin aparat video
$aparat_video_file= null;
$course_video_aparat = get_post_meta(get_the_ID(), $prefix . 'course_video_aparat', true);
if($course_video_aparat){
    $aparat_video_file = studi_get_aparat_file_link($course_video_aparat);
}
//end aparat video;

$thumb_image_size = 'shop_single';

$post_thumbnail_id = get_post_thumbnail_id( $post->ID );
$full_size_image   = wp_get_attachment_image_src( $post_thumbnail_id, 'full' );
$image_title       = get_post_field( 'post_excerpt', $post_thumbnail_id );
$wrapper_classes   = apply_filters( 'woocommerce_single_product_image_gallery_classes', array(
	'woocommerce-product-gallery',
) );
?>
<div class="<?php echo esc_attr( implode( ' ', array_map( 'sanitize_html_class', $wrapper_classes ) ) ); ?>" style="opacity: 0; transition: opacity .25s ease-in-out;">
	<div class="product-image-wrapper">
		<?php

		

		if ( has_post_thumbnail() ) {
		    $attributes = array(
			'title'                   => $image_title,
			'data-src'                => $full_size_image[0]
		);
			$html = get_the_post_thumbnail( $post->ID, 'full', $attributes );
		} else {
			$html  = sprintf( '<img src="%s" alt="%s" data-src="%s" data-large_image="%s" data-large_image_width="800" data-large_image_height="600" class="attachment-shop_single size-shop_single wp-post-image" />', esc_url( wc_placeholder_img_src() ), esc_html__( 'Awaiting product image', 'studiare' ), esc_url( wc_placeholder_img_src() ), esc_url( wc_placeholder_img_src() ) );
        }

		echo apply_filters( 'woocommerce_single_product_image_thumbnail_html', $html, $post_thumbnail_id ); ?>

		<?php if ( $course_video || $aparat_video_file ) : ?>
		<?php if($aparat_video_file){$course_video = $aparat_video_file;}
		
		?>
		<video id="studi_course_video_holder" width="100%" controls style="display:none;" >
		       
            <source id="studi_course_video" src="<?php echo esc_url( $course_video ); ?>" type="video/mp4">
                 <?php echo __('مرورگر شما از HTML5 پشتیبانی نمی کند.','studiare'); ?>
            </video>
        <div class="video-button hint--top" aria-label="<?php esc_html_e( 'Intro Video', 'studiare' ); ?>">
            <div class="studi_play_video"><svg viewBox="0 0 24 24" width="48" height="48" fill="#ffffff" xmlns="http://www.w3.org/2000/svg">
     <path d="M17.49 9.60001L5.6 16.77C4.9 17.19 4 16.69 4 15.87V7.87001C4 4.38001 7.77 2.20001 10.8 3.94001L15.39 6.58001L17.48 7.78001C18.17 8.19001 18.18 9.19001 17.49 9.60001Z"></path>
     <path d="M18.0908 15.46L14.0408 17.8L10.0008 20.13C8.55079 20.96 6.91079 20.79 5.72079 19.95C5.14079 19.55 5.21079 18.66 5.82079 18.3L18.5308 10.68C19.1308 10.32 19.9208 10.66 20.0308 11.35C20.2808 12.9 19.6408 14.57 18.0908 15.46Z"></path>
 </svg></div>
        </div>
		<?php endif; ?>

        <?php do_action( 'woocommerce_product_thumbnails' ); ?>
	</div>
</div>
<script>
jQuery(".studi_play_video").click(function(){
	jQuery(".product-image-wrapper .wp-post-image").hide();
	jQuery(this).hide();
	jQuery("#studi_course_video_holder").show();
	 video = document.getElementById('studi_course_video_holder');
	 video.play();
});
</script>